//# Advis' Ping-o-meter Script
//# Version: 1.0
//# http://advis.dhs.org/tribes2/

//Installation Instructions:
//	Place this .vl2 file into your Tribes2\GameData\base\ directory. 
//	Start Tribes2. 
//	Enter Settings -> Controls, scroll to the bottom and assign a key to "Toggle Ping-o-Meter"
//	Start Up a Game
//	Press the key you just assigned to start it.
//	Give feedback, good or bad, to advis@innocent.com

$PING::Max = 150;
$PING::Min = 150;

package PingOMeter {

	function TogglePingHud(%val) {
		if (%val)
			{
				if (isObject(PINGHud))
					PingHudDestroy();
				else
					{
						PingHudCreate();
						UpdatePing();
						GlobalActionMap.copyBind(moveMap, PingHudToggle);
					}
			}
	}


	function DispatchLaunchMode() {
		addMessageCallback('MsgPlayerScore', ShowPing);
		parent::DispatchLaunchMode();
	}


	function OptionsDlg::onWake(%this) {
		if ($PINGHudBind $= "false") {
			$RemapName[$RemapCount] = "Toggle Ping-o-Meter";
			$RemapCmd[$RemapCount]  = "TogglePingHud";
			$RemapCount++;
			$PINGHudBind = "true";
		}
		parent::onWake(%this);
	}


	function LoadingGui::onWake(%this){
		$CurrentPlayerName = getField( $pref::Player[$pref::Player::Current], 0);
		$CurrentPlayerTag = getField( wonGetAuthInfo(), 1);
		parent::onWake(%this);
	}


	function ShowPing(%v1, %v2, %clientId, %score, %ping, %pl) {
		if (isObject(PINGHud)){
			%player = $PlayerList[%clientId];

			if(StrStr(%player.name, $CurrentPlayerName) == 2) {
				PingHud.Current.settext(%player.ping @ "ms");
				CreateDot(%player.ping);
			}
		}
	}
 

 	function CreateDot(%ping) {
		%MeterExtentx = getWord(PingHud.Meter.extent, 0);
		%MeterPositionx = getWord(PingHud.Meter.position, 0);
		%MeterExtenty = getWord(PingHud.Meter.extent, 1);
    
		if (%ping > $PING::Max) {
			$PING::Max = %ping + 10;
			$PING::PixelConstant = 0;
		}
       
		if (%ping < $PING::Min) {
			$PING::Min = %ping - 10;
			$PING::PixelConstant = 0;
		}
    
		if($PING::PixelConstant == 0)
			$PING::PixelConstant = (($PING::Max - $PING::Min) / %MeterExtenty);



		PingHUD.Dot[$PING::DotNext] = new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			bitmap = "dot.png";
			position = (%MeterExtentx - 7) @ " " @ (%MeterExtenty - ((%ping - $PING::Min) / $PING::PixelConstant));
			extent = "1 1";
			border = "0";
			visible = "1";
		};
		PingHUD.Meter.add(PingHUD.Dot[$PING::DotNext]);
            
		PingHud.Meter.position = setWord(PingHud.Meter.position, 0, (%Meterpositionx - 1));
		PingHUD.Meter.extent = setword(PingHud.Meter.extent, 0, (%MeterExtentx + 1));

		$PING::DotNext++;
	}
 
 
	function UpdatePing() {
		if (isObject(PINGHud)) {
			commandToServer('getScores');
			schedule(2500, 0, UpdatePing);
		}
	}
 

	function PingHudCreate(){
		%posX = getWord(objectiveHUD.extent, 0) + getWord(objectiveHUD.position, 0);
		%posY = getWord(objectiveHUD.position, 1);

		PingHudDestroy();

		$PingHUD = new ShellFieldCtrl(PingHUD){
			profile = "GuiChatBackProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = (%posX+8) @ " " @ %posY;
			extent = "65 37";     // 65 37
			minExtent = "8 8";
			visible = "1";
		};
		playGui.add($PingHUD);

		PingHUD.Meter = new GuiControl(){
			profile = "GuiChatBackProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "0 0";
			extent = "70 37";
			minExtent = "8 8";
			visible = "1";
			opaque = false;
		};
		PingHUD.add(PingHUD.Meter);

		PingHUD.Line = new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 19";
			bitmap = "line.png";
			extent = "65 1";
			visible = "1";
		};
            PingHUD.add(PingHUD.Line);

		PingHUD.Current = new GuiTextCtrl() {
			profile = "GuiTextObjHudLeftProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "3 3";
			extent = "70 16";
			visible = "1";
			fontSize = "8";
			text = "Current Ping:";
		};
		PingHUD.add(PingHUD.Current);
	}


	function PingHudDestroy() {
		if (isObject(PINGHud)) {
			playGui.remove(PINGHud);
			PINGHud.delete();
		}
	}

};

activatePackage(PingOMeter);
$PINGHudBind = "false";

$PING::DotNext = 0;
$PING::PixelConstant = 0;
